--Fader Module

--Idea; plugin to the option window and load functions, then it should just run itself!
function initialisefader()
	--Run this on loading
		for i=1,#Bar do
			Bar[i]:fader()
		end
	-- add a callback
	handlefader = AddCallback(Player, "InCombatChanged", function(sender, args)
		for i=1,#Bar do
			if Bar[i]:IsVisible() then	--Line added to play nicely with the stance, runekeeper etc modules.
				if Player:IsInCombat() then
					Bar[i]:SetOpacity(Bar[i].Data.icmn)
				else
					Bar[i]:SetOpacity(Bar[i].Data.oocmn)
				end
			end
		end
	end)
end

--fader function; accepts Out Of Combat and In Combat MouseOver and MouseNot
function NewBar:fader()
	--Defaults
	local oocmo=	self.Data.oocmo or 1
	local icmo=		self.Data.icmo or 1
	local oocmn=	self.Data.oocmn or 1
	local icmn=		self.Data.icmn or 1

	--Store
	self.Data.oocmo,self.Data.icmo,self.Data.icmn,self.Data.oocmn=oocmo,icmo,icmn,oocmn

	--Right, if no fading is selected then this bar gets no fading events set, other wise set the nessecery events ONLY.

	if oocmo==icmo and oocmo==oocmn and oocmo==icmn then self:SetOpacity(icmn) self.Window.MouseEnter=nil self.Window.MouseLeave=nil return 0 end

	self.Window.MouseEnter=function()
		if ShowBars then return end
		if Watcher.flag then self.Window:SetVisible(true) self:SetOpacity(1) return end
		if self:IsVisible() then	--Line added to play nicely with the stance, runekeeper etc modules.
			if Player:IsInCombat() then
				self:SetOpacity(icmo)
			else
				self:SetOpacity(oocmo)
			end
		end		
	end
	
	self.Window.MouseLeave=function()
		if ShowBars then return end
		if Watcher.flag then self.Window:SetVisible(true) self:SetOpacity(1) return end
		if self:IsVisible() then	--Line added to play nicely with the stance, runekeeper etc modules.
			if Player:IsInCombat() then
				self:SetOpacity(icmn)
			else
				self:SetOpacity(oocmn)
			end
		end
	end
	
	--Set the current opacity
		self:SetOpacity(oocmn)
end

--New Option Box functions

table.insert(Opt.Module,
	function()
		Opt.Fader=CollapseBox("Fading Options","f",2,true)
		Opt.ListBox:AddItem(Opt.Fader)
		
		Opt.OOC=optionlabel(10,"ooc='Out-of-Combat'",true)
		Opt.IC=optionlabel(10,"ic='In Combat'",true)
		Opt.MO=optionlabel(10,"mo='Mouse Over'",true)
		Opt.MN=optionlabel(10,"mn='Mouse Not'",true)
		Opt.Fader.Content:AddItem(Opt.OOC)
		Opt.Fader.Content:AddItem(Opt.IC)
		Opt.Fader.Content:AddItem(Opt.MO)
		Opt.Fader.Content:AddItem(Opt.MN)
		
		Opt.oocmo=Opt.Slider("oocmo",		0,100,	function(k,i) k=k/100 Bar[i].Data.oocmo=k 	Bar[i]:fader() Opt.ChangePreview(k) end)
		Opt.icmo=Opt.Slider("icmo",			0,100,	function(k,i) k=k/100 Bar[i].Data.icmo=k 	Bar[i]:fader() Opt.ChangePreview(k) end)
		Opt.oocmn=Opt.Slider("oocmn",		0,100,	function(k,i) k=k/100 Bar[i].Data.oocmn=k 	Bar[i]:fader() Opt.ChangePreview(k) end)
		Opt.icmn=Opt.Slider("icmn",			0,100,	function(k,i) k=k/100 Bar[i].Data.icmn=k 	Bar[i]:fader() Opt.ChangePreview(k) end)
		
		Opt.Fader.Content:AddItem(Opt.oocmo)
		Opt.Fader.Content:AddItem(Opt.icmo)
		Opt.Fader.Content:AddItem(Opt.oocmn)
		Opt.Fader.Content:AddItem(Opt.icmn)
			
		Opt.Preview=optionlabel(10,"Preview of Opacity",true)--Turbine.UI.Control()
		--Opt.Preview:SetSize(100,20)
		Opt.Fader.Content:AddItem(Opt.Preview)
			function Opt.ChangePreview(k)
				Opt.Preview:SetBackColor(Turbine.UI.Color(k,1,1,1))
			end
		
		end )
		
table.insert(Opt.source,"oocmo")
table.insert(Opt.source,"icmo")
table.insert(Opt.source,"oocmn")
table.insert(Opt.source,"icmn")

table.insert(Opt.Updaters, 
	function()
		if Opt.oocmo~=nil then
			Opt.val.oocmo=Opt.val.oocmo*100
			Opt.val.icmo=Opt.val.icmo*100
			Opt.val.oocmn=Opt.val.oocmn*100
			Opt.val.icmn=Opt.val.icmn*100
		
			Opt.oocmo	:SetVal(Opt.val.oocmo)
			Opt.icmo	:SetVal(Opt.val.icmo)
			Opt.oocmn	:SetVal(Opt.val.oocmn)
			Opt.icmn	:SetVal(Opt.val.icmn)
			
			Opt.oocmo.sliderval:SetText(Opt.val.oocmo)
			Opt.icmo.sliderval:SetText(Opt.val.icmo)
			Opt.oocmn.sliderval:SetText(Opt.val.oocmn)
			Opt.icmn.sliderval:SetText(Opt.val.icmn)
		end
	end)
